The maximum coverage problem is a classical question in computer science, computational complexity theory, and operations research. It is a problem that is widely taught in approximation algorithms.
As input you are given several sets and a number k {\displaystyle k} . The sets may have some elements in common. You must select at most k {\displaystyle k} of these sets such that the maximum number of elements are covered, i.e. the union of the selected sets has maximal size.
Formally, (unweighted) Maximum Coverage
The maximum coverage problem is NP-hard, and cannot be approximated to within 1 − 1 e + o ( 1 ) ≈ 0.632 {\displaystyle 1-{\frac {1}{e}}+o(1)\approx 0.632} under standard assumptions. This result essentially matches the approximation ratio achieved by the generic greedy algorithm used for maximization of submodular functions with a cardinality constraint.[1]
The maximum coverage problem can be formulated as the following integer linear program.
The greedy algorithm for maximum coverage chooses sets according to one rule: at each stage, choose a set which contains the largest number of uncovered elements. It can be shown that this algorithm achieves an approximation ratio of 1 − 1 e {\displaystyle 1-{\frac {1}{e}}} .[2] ln-approximability results show that the greedy algorithm is essentially the best-possible polynomial time approximation algorithm for maximum coverage unless P = N P {\displaystyle P=NP} .[3]
The inapproximability results apply to all extensions of the maximum coverage problem since they hold the maximum coverage problem as a special case.
The Maximum Coverage Problem can be applied to road traffic situations; one such example is selecting which bus routes in a public transportation network should be installed with pothole detectors to maximise coverage, when only a limited number of sensors is available. This problem is a known extension of the Maximum Coverage Problem and was first explored in literature by Junade Ali and Vladimir Dyo.[4]
In the weighted version every element e j {\displaystyle e_{j}} has a weight w ( e j ) {\displaystyle w(e_{j})} . The task is to find a maximum coverage which has maximum weight. The basic version is a special case when all weights are 1 {\displaystyle 1} .
The greedy algorithm for the weighted maximum coverage at each stage chooses a set that contains the maximum weight of uncovered elements. This algorithm achieves an approximation ratio of 1 − 1 e {\displaystyle 1-{\frac {1}{e}}} .[1]
In the budgeted maximum coverage version, not only does every element e j {\displaystyle e_{j}} have a weight w ( e j ) {\displaystyle w(e_{j})} , but also every set S i {\displaystyle S_{i}} has a cost c ( S i ) {\displaystyle c(S_{i})} . Instead of k {\displaystyle k} that limits the number of sets in the cover a budget B {\displaystyle B} is given. This budget B {\displaystyle B} limits the total cost of the cover that can be chosen.
A greedy algorithm will no longer produce solutions with a performance guarantee. Namely, the worst case behavior of this algorithm might be very far from the optimal solution. The approximation algorithm is extended by the following way. First, define a modified greedy algorithm, that selects the set S i {\displaystyle S_{i}} that has the best ratio of weighted uncovered elements to cost. Second, among covers of cardinality 1 , 2 , . . . , k − 1 {\displaystyle 1,2,...,k-1} , find the best cover that does not violate the budget. Call this cover H 1 {\displaystyle H_{1}} . Third, find all covers of cardinality k {\displaystyle k} that do not violate the budget. Using these covers of cardinality k {\displaystyle k} as starting points, apply the modified greedy algorithm, maintaining the best cover found so far. Call this cover H 2 {\displaystyle H_{2}} . At the end of the process, the approximate best cover will be either H 1 {\displaystyle H_{1}} or H 2 {\displaystyle H_{2}} . This algorithm achieves an approximation ratio of 1 − 1 e {\displaystyle 1-{1 \over e}} for values of k ≥ 3 {\displaystyle k\geq 3} . This is the best possible approximation ratio unless N P ⊆ D T I M E ( n O ( log log n ) ) {\displaystyle NP\subseteq DTIME(n^{O(\log \log n)})} .[5]
In the generalized maximum coverage version every set S i {\displaystyle S_{i}} has a cost c ( S i ) {\displaystyle c(S_{i})} , element e j {\displaystyle e_{j}} has a different weight and cost depending on which set covers it. Namely, if e j {\displaystyle e_{j}} is covered by set S i {\displaystyle S_{i}} the weight of e j {\displaystyle e_{j}} is w i ( e j ) {\displaystyle w_{i}(e_{j})} and its cost is c i ( e j ) {\displaystyle c_{i}(e_{j})} . A budget B {\displaystyle B} is given for the total cost of the solution.
The algorithm uses the concept of residual cost/weight. The residual cost/weight is measured against a tentative solution and it is the difference of the cost/weight from the cost/weight gained by a tentative solution.
The algorithm has several stages. First, find a solution using greedy algorithm. In each iteration of the greedy algorithm the tentative solution is added the set which contains the maximum residual weight of elements divided by the residual cost of these elements along with the residual cost of the set. Second, compare the solution gained by the first step to the best solution which uses a small number of sets. Third, return the best out of all examined solutions. This algorithm achieves an approximation ratio of 1 − 1 / e − o ( 1 ) {\displaystyle 1-1/e-o(1)} .[6]